package jp.co.sds_corp.hibiya.monitor;

import java.awt.Dialog;
import java.awt.Font;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ResourceBundle;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JDialog;

import jp.co.sds_corp.hibiya.server.IChecker;
import jp.co.sds_corp.util.window.ColumnSelectPanel;
import jp.co.sds_corp.util.window.WindowUtility;

/**
* {@link IChecker}一覧の表示設定を行うダイアログです。
*/
public class ColumnDialog extends JDialog
{
	private static final long serialVersionUID = 1L;
	JButton BTN_OK = new JButton( "OK" );
	JButton BTN_CANCEL = new JButton( "Cancel" );

	SetupParam		setup;
	MonitorParam	prm;
	ColumnSelectPanel   cp;
	int			nRes = -1;
	ResourceBundle	res;

	public ColumnDialog( Frame parent, SetupParam setup ) {
		super( parent );
		this.setup = setup;
		createControls();
	}

	public ColumnDialog( Dialog parent, SetupParam setup ) {
		super( parent );
		this.setup = setup;
		createControls();
	}

	private void createControls() {
		res = ResourceBundle.getBundle( "resource.monitor" );
		setModal( true );
		setResizable( false );
		String title = res.getString( "column.title" );
		setTitle( title );
		setSize( 477, 300 );
		getContentPane().setLayout( new BoxLayout(
			getContentPane(), BoxLayout.Y_AXIS ));
		Font	f = new Font( "Dialog", Font.PLAIN, 14 );
		setFont( f );
		WindowUtility.setHideOnEscape( this );

		cp = new ColumnSelectPanel();
		getContentPane().add( cp );

		Box box1 = new Box( BoxLayout.X_AXIS );
		box1.add( BTN_OK );
		box1.add( BTN_CANCEL );
		getContentPane().add( box1 );
		getRootPane().setDefaultButton( BTN_OK );

		BTN_OK.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent ev ) {
				onOk();
			}
		});
		BTN_CANCEL.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent ev ) {
				onCancel();
			}
		});
	}

	public void onOk() {
		setVisible( false );
		if ( cp.isChange()) {
			prm.setColumn( cp.getSelected() );
		}
		nRes = 1;
	}

	public void onCancel() {
		nRes = 0;
		setVisible( false );
	}

	public void setData( MonitorParam prm ) {
		this.prm = prm;
		cp.setColumn( prm.listAllName(), prm.listColumnName());
	}

	public int getResult() {
		return nRes;
	}

	public void setEnabled( boolean bEn ) {
		BTN_OK.setEnabled( bEn );
	}

}
