package jp.co.sds_corp.hibiya.monitor;

import jp.co.sds_corp.hibiya.connector.IConnector;
import jp.co.sds_corp.hibiya.server.IChecker;

/**
* {@link MonitorTree}のNode情報を保持します。
*/
public class NodeInfo
{
	public enum Level {
		ROOT,
		CONNECTOR,
		GROUP,
		CHECKER
	};

	Level	level;
	IConnector con;
	MonitorParam	prm;
	IChecker		mon;

	public NodeInfo( Level level ) {
		this.level = level;
	}
	public NodeInfo( Level level, IConnector con ) {
		this.level = level;
		this.con = con;
	}
	public NodeInfo( Level level, IConnector con, MonitorParam prm ) {
		this.level = level;
		this.con = con;
		this.prm = prm;
	}
	public NodeInfo( Level level, IConnector con, MonitorParam prm,
					IChecker mon )
	{
		this.level = level;
		this.con = con;
		this.prm = prm;
		this.mon = mon;
	}
	public Level getLevel() {
		return level;
	}

	public IConnector getConnector() {
		return con;
	}
	public MonitorParam getParam() {
		return prm;
	}
	public void setChecker( IChecker mon ) {
		this.mon = mon;
	}
	public IChecker getChecker() {
		return mon;
	}

	public String toString() {
		switch ( level ) {
		case ROOT: return "";
		case CONNECTOR:
			return con.getName();
		case GROUP:
			return prm.getName();
		case CHECKER:
			return mon.getName();
		}
		return "";
	}
}
