package jp.co.sds_corp.hibiya.monitor.action;

import java.io.File;
import java.util.ResourceBundle;

import javax.swing.BoxLayout;
import javax.swing.border.TitledBorder;

import jp.co.sds_corp.hibiya.action.FileAction;
import jp.co.sds_corp.hibiya.action.IAction;
import jp.co.sds_corp.util.window.FileSelector;

/**
* ファイル保存に関する設定をするPanelです。
* @author	小見山　聡
*/
public class FilePanel extends AbstractPanel
{
	private static final long serialVersionUID = 1L;
	FileSelector	fs;
	ResourceBundle	res;

	/**
	* このパネルを初期化します。
	*/
	public FilePanel() {
		res = ResourceBundle.getBundle( "resource.monitor" );
		String text;
		text = res.getString( "action.file.title" );
		setBorder( new TitledBorder( text ));
		setLayout( new BoxLayout( this, BoxLayout.Y_AXIS ));

		text = res.getString( "action.file.filter" );
		fs = new FileSelector( new File( "." ).getAbsolutePath(), text );
		add( fs );
		add( VAL_MINSTAT );
		add( PNL_UNIQ );
	}

	public void setEnabled( boolean bEn ) {
		super.setEnabled( bEn );
		fs.setEnabled( bEn );
	}

	public void clear() {
		super.clear();
		fs.setSelection( null );
	}

	public void setAction( IAction action ) {
		super.setAction( action );
		if ( action == null ) {
			clear();
			return;
		}
		FileAction fa = (FileAction )action;
		fs.setSelection( fa.getFile() );
	}

	public void updateAction() throws Exception {
		super.updateAction();
		FileAction fa = (FileAction )action;
		String val = fs.getSelection();
		if ( val == null || val.length() == 0 ) {
			String msg = res.getString( "action.file.err1.message" );
			throw( new Exception( msg ));
		}
		fa.setFile( val );
	}

}

