package	jp.co.sds_corp.hibiya.monitor.checker;

import java.util.List;

import jp.co.sds_corp.hibiya.connector.IConnector;
import jp.co.sds_corp.hibiya.monitor.Column;
import jp.co.sds_corp.hibiya.monitor.ThresholdPanel;
import jp.co.sds_corp.hibiya.server.IChecker;

/**
* {@link IChecker}を設定するJPanelのインターフェースです。
*/
public interface ICheckerPanel
{
	/**
	* 監視対象のクラスを取得します。
	* @return	monitorのクラス
	*/
	public Class<? extends IChecker> getCheckerClass();

	/**
	* 監視対象のモニタ(monitor)を設定します。
	* @param	var		設定するデータ
	*/
	public void setChecker( IChecker var );

	/**
	* 監視対象のモニタ(monitor)を取得します。
	* @return	monitorの内容
	*/
	public IChecker getChecker();

	/**
	* 監視対象のコネクタを設定します。
	* @param	var		設定するデータ
	*/
	public void setConnector( IConnector var );

	/**
	* 監視対象のモニタに設定情報を設定します。
	*/
	public void checkSetup() throws Exception;
	/**
	* 監視対象のモニタに設定情報を設定します。
	*/
	public void setupChecker( IChecker mon ) throws Exception;

	/**
	* 監視対象の全てのカラムを取得します。
	* @return	監視対象の全てのカラム
	*/
	public List<Column> getAllColumn();

	/**
	* ThresholdPanelを設定します。
	* @param    var     設定するデータ
	*/
	public void setThresholdPanel( ThresholdPanel var );

	public void setEnabled( boolean bEn );
}
