package jp.co.sds_corp.hibiya.monitor.checker;

import java.util.Arrays;

import javax.swing.BoxLayout;
import javax.swing.JPanel;

import jp.co.sds_corp.hibiya.monitor.Column;
import jp.co.sds_corp.hibiya.server.IChecker;
import jp.co.sds_corp.hibiya.server.ShellChecker;
import jp.co.sds_corp.util.window.ValuePanel;

/**
* {@link ShellChecker}の設定を行うパネルです。
*/
public class ShellPanel extends AbstractPanel
{
	private static final long serialVersionUID = 1L;
	ValuePanel	VAL_CMD = new ValuePanel( ValuePanel.ReturnType.STRING, "Command:" );
	ValuePanel	VAL_DIR = new ValuePanel( ValuePanel.ReturnType.STRING, "Dir:" );
	ValuePanel	VAL_EXIT = new ValuePanel( ValuePanel.ReturnType.INT, "NormalExit:" );

	public ShellPanel() {
		testChecker = new ShellChecker();
		createSetupPanel();
	}

	void createSetupPanel() {
		JPanel pnl = new JPanel();
		pnl.setLayout( new BoxLayout( pnl, BoxLayout.Y_AXIS ));
		pnl.add( VAL_NAME );
		pnl.add( VAL_CMD );
		pnl.add( VAL_DIR );
		pnl.add( VAL_EXIT );
		pnl.add( VAL_INT );
		pnl.add( CHK_HIST );
		add( pnl );
		add( BTN_TEST );
	}

	public void setChecker( IChecker var ) {
		super.setChecker( var );
		ShellChecker mon = (ShellChecker )var;
		VAL_CMD.setValue( mon.getCommand() );
		VAL_DIR.setValue( mon.getDir() );
		VAL_EXIT.setValue( String.valueOf( mon.getNormalExit()) );
	}
	public void checkSetup() throws Exception {
		super.checkSetup();
		String var;
		var = (String )VAL_CMD.getValue();
		if ( var == null || var.length() == 0 ) {
			String msg = res.getString( "checker.shell.err1.message" );
			throw( new Exception( msg ));
		}
	}
	public void setupChecker( IChecker chk ) throws Exception {
		super.setupChecker( chk );
		ShellChecker mon = (ShellChecker )chk;
		mon.setCommand( (String )VAL_CMD.getValue() );
		mon.setDir( (String )VAL_DIR.getValue() );
		mon.setNormalExit( ((Integer )VAL_EXIT.getValue()).intValue() );
	}

	public void setEnabled( boolean bEn ) {
		super.setEnabled( bEn );
		VAL_CMD.setEnabled( bEn );
		VAL_DIR.setEnabled( bEn );
		VAL_EXIT.setEnabled( bEn );
	}

	public Class<? extends IChecker> getCheckerClass() {
		return ShellChecker.class;
	}

	static Column[] col = {
		new Column( "Status" ), new Column( "Name" ),
		new Column( "Command" ), new Column( "Dir" ),
		new Column( "NormalExit" ),
		new Column( "Interval" ), new Column( "Exception" )
	};
	static java.util.List<Column> colList = Arrays.asList( col );

	public java.util.List<Column> getAllColumn() {
		return colList;
	}

}

